/* polygon.c autoXml generated file */

#include "common.h"
#include "xap.h"
#include "polygon.h"

void *polygonStartHandler(struct xap *xp, char *name, char **atts);
/* Called by expat with start tag.  Does most of the parsing work. */

void polygonEndHandler(struct xap *xp, char *name);
/* Called by expat with end tag.  Checks all required children are loaded. */


void polygonPolygonSave(struct polygonPolygon *obj, int indent, FILE *f)
/* Save polygonPolygon to file. */
{
struct polygonPoint *polygonPoint;
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<POLYGON");
fprintf(f, " id=\"%s\"", obj->id);
fprintf(f, ">");
fprintf(f, "\n");
polygonDescriptionSave(obj->polygonDescription, indent+2, f);
for (polygonPoint = obj->polygonPoint; polygonPoint != NULL; polygonPoint = polygonPoint->next)
   {
   polygonPointSave(polygonPoint, indent+2, f);
   }
xapIndent(indent, f);
fprintf(f, "</POLYGON>\n");
}

struct polygonPolygon *polygonPolygonLoad(char *fileName)
/* Load polygonPolygon from file. */
{
struct polygonPolygon *obj;
xapParseAny(fileName, "POLYGON", polygonStartHandler, polygonEndHandler, NULL, &obj);
return obj;
}

void polygonDescriptionSave(struct polygonDescription *obj, int indent, FILE *f)
/* Save polygonDescription to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DESCRIPTION>");
fprintf(f, "%s", obj->text);
fprintf(f, "</DESCRIPTION>\n");
}

struct polygonDescription *polygonDescriptionLoad(char *fileName)
/* Load polygonDescription from file. */
{
struct polygonDescription *obj;
xapParseAny(fileName, "DESCRIPTION", polygonStartHandler, polygonEndHandler, NULL, &obj);
return obj;
}

void polygonPointSave(struct polygonPoint *obj, int indent, FILE *f)
/* Save polygonPoint to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<POINT");
fprintf(f, " x=\"%f\"", obj->x);
fprintf(f, " y=\"%f\"", obj->y);
fprintf(f, "->\n");
}

struct polygonPoint *polygonPointLoad(char *fileName)
/* Load polygonPoint from file. */
{
struct polygonPoint *obj;
xapParseAny(fileName, "POINT", polygonStartHandler, polygonEndHandler, NULL, &obj);
return obj;
}

void *polygonStartHandler(struct xap *xp, char *name, char **atts)
/* Called by expat with start tag.  Does most of the parsing work. */
{
struct xapStack *st = xp->stack+1;
int depth = xp->stackDepth;
int i;

if (sameString(name, "POLYGON"))
    {
    struct polygonPolygon *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    return obj;
    }
else if (sameString(name, "DESCRIPTION"))
    {
    struct polygonDescription *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "POLYGON"))
            {
            struct polygonPolygon *parent = st->object;
            slAddHead(&parent->polygonDescription, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "POINT"))
    {
    struct polygonPoint *obj;
    AllocVar(obj);
    obj->z = 0;
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "x"))
            obj->x = atof(val);
        else if (sameString(name, "y"))
            obj->y = atof(val);
        else if (sameString(name, "z"))
            obj->z = atof(val);
        }
    if (depth > 1)
        {
        if  (sameString(st->elName, "POLYGON"))
            {
            struct polygonPolygon *parent = st->object;
            slAddHead(&parent->polygonPoint, obj);
            }
        }
    return obj;
    }
else
    {
    xapSkip(xp);
    return NULL;
    }
}

void polygonEndHandler(struct xap *xp, char *name)
/* Called by expat with end tag.  Checks all required children are loaded. */
{
struct xapStack *stack = xp->stack;
if (sameString(name, "POLYGON"))
    {
    struct polygonPolygon *obj = stack->object;
    if (obj->polygonDescription != NULL && obj->polygonDescription->next != NULL)
        xapError(xp, "Multiple DESCRIPTION");
    if (obj->polygonPoint == NULL)
        xapError(xp, "Missing POINT");
    slReverse(&obj->polygonPoint);
    }
else if (sameString(name, "DESCRIPTION"))
    {
    struct polygonDescription *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
}

int main(int argc, char *argv[])
/* Test driver for polygon routines */
{
struct polygonPolygon *obj;
if (argc != 2)
    errAbort("Please run again with a xml filename.");
obj = polygonPolygonLoad(argv[1]);
polygonPolygonSave(obj, 0, stdout);
return 0;
}
